import * as cdk from "../../core";
import * as cfn_parse from "../../core/lib/cfn-parse";
/**
 * Properties for defining a `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export interface CfnExperimentTemplateProps {
    /**
     * `AWS::FIS::ExperimentTemplate.description`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-description
     */
    readonly description: string;
    /**
     * `AWS::FIS::ExperimentTemplate.roleArn`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-rolearn
     */
    readonly roleArn: string;
    /**
     * `AWS::FIS::ExperimentTemplate.stopConditions`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-stopconditions
     */
    readonly stopConditions: Array<CfnExperimentTemplate.ExperimentTemplateStopConditionProperty | cdk.IResolvable> | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.tags`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-tags
     */
    readonly tags: {
        [key: string]: (string);
    } | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.targets`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-targets
     */
    readonly targets: {
        [key: string]: (CfnExperimentTemplate.ExperimentTemplateTargetProperty | cdk.IResolvable);
    } | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.actions`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-actions
     */
    readonly actions?: {
        [key: string]: (CfnExperimentTemplate.ExperimentTemplateActionProperty | cdk.IResolvable);
    } | cdk.IResolvable;
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare class CfnExperimentTemplate extends cdk.CfnResource implements cdk.IInspectable {
    /**
     * The CloudFormation resource type name for this resource class.
     *
     * @external
     */
    static readonly CFN_RESOURCE_TYPE_NAME = "AWS::FIS::ExperimentTemplate";
    /**
     * A factory method that creates a new instance of this class from an object
     * containing the CloudFormation properties of this resource.
     * Used in the @aws-cdk/cloudformation-include module.
     *
     * @internal
     */
    static _fromCloudFormation(scope: cdk.Construct, id: string, resourceAttributes: any, options: cfn_parse.FromCloudFormationOptions): CfnExperimentTemplate;
    /**
     * @external
     * @cloudformationAttribute id
     */
    readonly attrId: string;
    /**
     * `AWS::FIS::ExperimentTemplate.description`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-description
     */
    description: string;
    /**
     * `AWS::FIS::ExperimentTemplate.roleArn`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-rolearn
     */
    roleArn: string;
    /**
     * `AWS::FIS::ExperimentTemplate.stopConditions`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-stopconditions
     */
    stopConditions: Array<CfnExperimentTemplate.ExperimentTemplateStopConditionProperty | cdk.IResolvable> | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.tags`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-tags
     */
    tags: {
        [key: string]: (string);
    } | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.targets`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-targets
     */
    targets: {
        [key: string]: (CfnExperimentTemplate.ExperimentTemplateTargetProperty | cdk.IResolvable);
    } | cdk.IResolvable;
    /**
     * `AWS::FIS::ExperimentTemplate.actions`.
     *
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html#cfn-fis-experimenttemplate-actions
     */
    actions: {
        [key: string]: (CfnExperimentTemplate.ExperimentTemplateActionProperty | cdk.IResolvable);
    } | cdk.IResolvable | undefined;
    /**
     * Create a new `AWS::FIS::ExperimentTemplate`.
     *
     * @param scope - scope in which this resource is defined.
     * @param id - scoped id of the resource.
     * @param props - resource properties.
     * @external
     */
    constructor(scope: cdk.Construct, id: string, props: CfnExperimentTemplateProps);
    /**
     * (experimental) Examines the CloudFormation resource and discloses attributes.
     *
     * @param inspector - tree inspector to collect and process attributes.
     * @experimental
     */
    inspect(inspector: cdk.TreeInspector): void;
    /**
     * @external
     */
    protected get cfnProperties(): {
        [key: string]: any;
    };
    /**
     * @external
     */
    protected renderProperties(props: {
        [key: string]: any;
    }): {
        [key: string]: any;
    };
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html
     */
    interface ExperimentTemplateActionProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionProperty.actionId`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html#cfn-fis-experimenttemplate-experimenttemplateaction-actionid
         */
        readonly actionId?: string;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionProperty.description`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html#cfn-fis-experimenttemplate-experimenttemplateaction-description
         */
        readonly description?: string;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionProperty.parameters`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html#cfn-fis-experimenttemplate-experimenttemplateaction-parameters
         */
        readonly parameters?: CfnExperimentTemplate.ExperimentTemplateActionItemParameterMapProperty | cdk.IResolvable;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionProperty.startAfter`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html#cfn-fis-experimenttemplate-experimenttemplateaction-startafter
         */
        readonly startAfter?: CfnExperimentTemplate.ExperimentTemplateActionItemStartAfterListProperty | cdk.IResolvable;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionProperty.targets`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateaction.html#cfn-fis-experimenttemplate-experimenttemplateaction-targets
         */
        readonly targets?: CfnExperimentTemplate.ExperimentTemplateActionItemTargetMapProperty | cdk.IResolvable;
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateactionitemparametermap.html
     */
    interface ExperimentTemplateActionItemParameterMapProperty {
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateactionitemstartafterlist.html
     */
    interface ExperimentTemplateActionItemStartAfterListProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateActionItemStartAfterListProperty.ExperimentTemplateActionItemStartAfterList`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateactionitemstartafterlist.html#cfn-fis-experimenttemplate-experimenttemplateactionitemstartafterlist-experimenttemplateactionitemstartafterlist
         */
        readonly experimentTemplateActionItemStartAfterList?: string[];
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplateactionitemtargetmap.html
     */
    interface ExperimentTemplateActionItemTargetMapProperty {
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatestopcondition.html
     */
    interface ExperimentTemplateStopConditionProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateStopConditionProperty.source`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatestopcondition.html#cfn-fis-experimenttemplate-experimenttemplatestopcondition-source
         */
        readonly source: string;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateStopConditionProperty.value`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatestopcondition.html#cfn-fis-experimenttemplate-experimenttemplatestopcondition-value
         */
        readonly value?: string;
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html
     */
    interface ExperimentTemplateTargetProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetProperty.filters`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html#cfn-fis-experimenttemplate-experimenttemplatetarget-filters
         */
        readonly filters?: CfnExperimentTemplate.ExperimentTemplateTargetFilterListProperty | cdk.IResolvable;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetProperty.resourceArns`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html#cfn-fis-experimenttemplate-experimenttemplatetarget-resourcearns
         */
        readonly resourceArns?: CfnExperimentTemplate.ResourceArnListProperty | cdk.IResolvable;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetProperty.resourceTags`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html#cfn-fis-experimenttemplate-experimenttemplatetarget-resourcetags
         */
        readonly resourceTags?: CfnExperimentTemplate.TagMapProperty | cdk.IResolvable;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetProperty.resourceType`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html#cfn-fis-experimenttemplate-experimenttemplatetarget-resourcetype
         */
        readonly resourceType: string;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetProperty.selectionMode`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetarget.html#cfn-fis-experimenttemplate-experimenttemplatetarget-selectionmode
         */
        readonly selectionMode: string;
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfilter.html
     */
    interface ExperimentTemplateTargetFilterProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetFilterProperty.path`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfilter.html#cfn-fis-experimenttemplate-experimenttemplatetargetfilter-path
         */
        readonly path: string;
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetFilterProperty.values`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfilter.html#cfn-fis-experimenttemplate-experimenttemplatetargetfilter-values
         */
        readonly values: CfnExperimentTemplate.ExperimentTemplateTargetFilterValuesProperty | cdk.IResolvable;
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfilterlist.html
     */
    interface ExperimentTemplateTargetFilterListProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetFilterListProperty.ExperimentTemplateTargetFilterList`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfilterlist.html#cfn-fis-experimenttemplate-experimenttemplatetargetfilterlist-experimenttemplatetargetfilterlist
         */
        readonly experimentTemplateTargetFilterList?: Array<CfnExperimentTemplate.ExperimentTemplateTargetFilterProperty | cdk.IResolvable> | cdk.IResolvable;
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfiltervalues.html
     */
    interface ExperimentTemplateTargetFilterValuesProperty {
        /**
         * `CfnExperimentTemplate.ExperimentTemplateTargetFilterValuesProperty.ExperimentTemplateTargetFilterValues`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-experimenttemplatetargetfiltervalues.html#cfn-fis-experimenttemplate-experimenttemplatetargetfiltervalues-experimenttemplatetargetfiltervalues
         */
        readonly experimentTemplateTargetFilterValues?: string[];
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-resourcearnlist.html
     */
    interface ResourceArnListProperty {
        /**
         * `CfnExperimentTemplate.ResourceArnListProperty.ResourceArnList`.
         *
         * @external
         * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-resourcearnlist.html#cfn-fis-experimenttemplate-resourcearnlist-resourcearnlist
         */
        readonly resourceArnList?: string[];
    }
}
/**
 * A CloudFormation `AWS::FIS::ExperimentTemplate`.
 *
 * @external
 * @cloudformationResource AWS::FIS::ExperimentTemplate
 * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-fis-experimenttemplate.html
 */
export declare namespace CfnExperimentTemplate {
    /**
     * @external
     * @link http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-fis-experimenttemplate-tagmap.html
     */
    interface TagMapProperty {
    }
}
